//  Initialize the spin system

#include <stdio.h>
#include "nummrit.h"
#include "maxvalue.h"
#include "spincom.h"
#include "matutil.h"

//#define DUMP_LOG

void nitspn()
{
	double cutfrq = 1.0e06;

#ifdef DUMP_LOG
	FILE *ofp;
#endif

// allocate space for matrices

	// /grpcom/
#ifdef DUMP_LOG
	ofp = fopen("matdump.txt", "w");
	fprintf(ofp, "\n\n*** nitspin():grpcom  isocom and prmcom \n");
	fclose(ofp);
#endif

	cshift = vector(1, MAXGRP);
	cup = matrix(1, MAXGRP, 1, MAXGRP);
	symcup = matrix(1, MAXGRP, 1, MAXGRP);
	dip = matrix(1, MAXGRP, 1, MAXGRP);
	symdip = matrix(1, MAXGRP, 1, MAXGRP);
	grpiso = ivector(1, MAXGRP);
	nucg= ivector(1, MAXGRP);
	pairg= ivector(1, MAXGRP);
	grpspn= ivector(1, MAXGRP);
//	fmaxg = imatrix(1, MAXGRP, 1, MAXGRP);
	agpb= ivector(1, MAXGRP);

	// /isocom/
	tiiso = vector(1, MAXISO);
	tliso = vector(1, MAXISO);
	fliso = vector(1, MAXISO);
	fuiso = vector(1, MAXISO);
	isospn = ivector(1, MAXISO);
	ntiso = ivector(1, MAXISO);
	misopa = ivector(1, MAXISO);
	misopb = ivector(1, MAXISO);

	// /prmcom/
	asnhi = vector(1, MAXGRP);
	asnlow = vector(1, MAXGRP);
	rhics = vector(1, MAXGRP);
	rlocs = vector(1, MAXGRP);
	rhiccj = matrix(1, MAXGRP, 1, MAXGRP);
	rloccj = matrix(1, MAXGRP, 1, MAXGRP);
	rhiscj = matrix(1, MAXGRP, 1, MAXGRP);
	rloscj = matrix(1, MAXGRP, 1, MAXGRP);
	rhiccd = matrix(1, MAXGRP, 1, MAXGRP);
	rloccd = matrix(1, MAXGRP, 1, MAXGRP);
	rhiscd = matrix(1, MAXGRP, 1, MAXGRP);
	rloscd = matrix(1, MAXGRP, 1, MAXGRP);
	asnmin = ivector(1, MAXGRP);
	asnnum = ivector(1, MAXGRP);
	prmmap = imatrix(1, 4, 0, MAXVAR);
	ivcs = ivector(1, MAXGRP);
	ivcup = imatrix(1, MAXGRP, 1, MAXGRP);
	ivdip = imatrix(1, MAXGRP, 1, MAXGRP);

	// common block /spincm/, etc. initilization
	niso = 0; ngrp = 0; nvar = 0;
	prmsiz = 4; prmnum = 1; prmi = 2; 
    prmj = 3; prmd = 4; lowvar = 0;
	rngdef = 1.0e9; rngnit = 1.5e9; rngmin = 0.01;
	
	// /grpcom/
	symspn = FALSE; anydip = FALSE;

	dclear(MAXGRP, cshift, 0.0);
	iclear(MAXGRP, grpiso, 0);
	iclear(MAXGRP, nucg, 0);
	iclear(MAXGRP, pairg, 0);

	iclear(MAXGRP, grpspn, 0);

//	imatclear(fmaxg, 1, MAXGRP, 1, MAXGRP, 0);
	for(int i = 1; i <= MAXGRP; i++)
		for(int j = 0; j <= MAXGRP; j++)
			fmaxg[i][j] = 0;

	iclear(MAXGRP, agpb, 0);

	matclear(cup, 1, MAXGRP, 1, MAXGRP, 0.0);
	matclear(dip, 1, MAXGRP, 1, MAXGRP, 0.0);
	matclear(symcup, 1, MAXGRP, 1, MAXGRP, 0.0);
	matclear(symdip, 1, MAXGRP, 1, MAXGRP, 0.0);

	// /isocom/
	km2p = 0;
	dclear(MAXISO, tiiso, 0.0);
//	dclear(MAXISO, tliso, 0.050);		///////////////////////////////
	dclear(MAXISO, tliso, tliso_val);	///////////////////////////////
	dclear(MAXISO, fliso, -cutfrq);
	dclear(MAXISO, fuiso, cutfrq);
	iclear(MAXISO, isospn, 1);
	iclear(MAXISO, ntiso, 0);
	iclear(MAXISO, misopa, 0);

	// /prmcom/
	dclear(MAXGRP, rhics, rngnit);
	dclear(MAXGRP, rlocs, -rngnit);
	matclear(rhiccj, 1, MAXGRP, 1, MAXGRP, rngnit);
	matclear(rloccj, 1, MAXGRP, 1, MAXGRP, -rngnit);
	matclear(rhiscj, 1, MAXGRP, 1, MAXGRP, rngnit);
	matclear(rloscj, 1, MAXGRP, 1, MAXGRP, -rngnit);
	matclear(rhiccd, 1, MAXGRP, 1, MAXGRP, rngnit);
	matclear(rloccd, 1, MAXGRP, 1, MAXGRP, -rngnit);
	matclear(rhiscd, 1, MAXGRP, 1, MAXGRP, rngnit);
	matclear(rloscd, 1, MAXGRP, 1, MAXGRP, -rngnit);
	imatclear(ivcup, 1, MAXGRP, 1, MAXGRP, 0);
	imatclear(ivdip, 1, MAXGRP, 1, MAXGRP, 0);
	imatclear(prmmap, 1, 4, 0, MAXVAR, 0);
	iclear(MAXGRP, ivcs, 0);

}

#ifdef DUMP_LOG
#undef DUMP_LOG
#endif


