//  Load the Xsim/SpinWorks type couplings into the NUMARIT variables

#include <stdio.h>
#include "nummrit.h"
#include "maxvalue.h"
#include <string.h>
#include <math.h>


// /grpcom/
extern double	*cshift, **cup, **symcup,
				**dip, **symdip;
extern int		*grpiso, *nucg, *pairg,
				*grpspn, fmaxg[MAXGRP+1][MAXGRP+1], *agpb;
extern short	anydip, symspn;
extern char		grpnam[MXGNAM + 1][MAXGRP + 1];

// /isocom/
extern double	*tiiso, *tliso,
				*fliso, *fuiso;
extern int		*isospn, *ntiso,
				*misopa, *misopb, km2p;
extern char		isonam[MXINAM + 1][MAXISO + 1];
extern char		prtiso[MAXISO + 2];

// /optcom/
extern double	rmscon, rmsdiv, rmslim, damp, asnlim,
				ignlim, itrfac, linwid, asnrms;
extern int		itrlim, itrmin, asnmod;
extern short	anyasn, wgtrms;

// /prmcom/
extern int		prmsiz, prmnum, prmi, 
				prmj, prmd, lowvar;
extern double	rngdef, rngnit, rngmin;
extern double	*asnhi, *asnlow,
				*rhics, *rlocs, rngfra,
				**rhiccj, **rloccj,
				**rhiscj, **rloscj,
				**rhiccd, **rloccd,
				**rhiscd, **rloscd;
extern int		*asnmin, *asnnum,
				**prmmap, *ivcs, // prmap runs from 0 to 4  CHECK!!!
				**ivcup, **ivdip;
extern short	chkasn, difzer[];

// /spncom/
extern int		ngrp, niso, nvar;

// /flagcm/
extern short	autasn, autdel, optmiz, prtptl,
				prtkey, prtdif, prtvcm, pracnd;

// /sioopt/
extern short	echoit, tracit;

extern double j_coupling[MAX_SHIFTS][MAX_SHIFTS][MAX_SYSTEMS];
extern double d_coupling[MAX_SHIFTS][MAX_SHIFTS][MAX_SYSTEMS];
extern int	  active_system;

//extern CString sim_out;

/////////////////////////////////////////////////////////////////////////////////////////

int load_couplings(const char *sim_out)
{
	int error = FALSE;
	short debug = FALSE;
	int i,j;
	FILE *ofp = fopen(sim_out, "a");

	for(i = 1; i <=ngrp; i++)
	{
		for(int j = 1; j <=ngrp; j++)
		{
			cup[i][j] = j_coupling[i-1][j-1][active_system];
			dip[i][j] = d_coupling[i-1][j-1][active_system];
		}
	}

	fprintf(ofp, "\n\nScalar coupling constants:\n\n");
	for(i = 1; i <=ngrp; i++)
	{
		for(j = 1; j <=ngrp; j++)
		{
			if((j > i) || (pairg[i] == 2 && pairg[j] == 2))
				fprintf(ofp, "   j[%2d,%2d] =  \tj[%s,%s] = \t%f\n", 
					i, j, grpnam[i], grpnam[j], cup[i][j]);
		}
	}

	fprintf(ofp, "\n\nDipolar coupling constants:\n\n");
	for(i = 1; i <=ngrp; i++)
	{
		for(j = 1; j <=ngrp; j++)
		{
			if(fabs(dip[i][j]) > 0)
				fprintf(ofp, "   d[%2d,%2d] = \td[%s,%s] = \t%f\n", 
					i, j, grpnam[i], grpnam[j], dip[i][j]);
		}
	}

	fclose(ofp);
	return error;
}


