// definitions file for MS C++ port of Nummrit

//  undo possible MFC conflict
#ifdef ERROR
#undef	ERROR
#endif

#define ERROR  -1
#define INPUT_EOF  -2
#define TRUE  1
#define FALSE  0
#define INPUT_MAX 256
#define MAX_SHIFTS 12
#define MAX_SYSTEMS 10
#define PEAKMAX 20000

#define N_OPTIONS 20
#define MAX_ENTRY 20
#define MAX_POP 3
#define FULL 1
#define PART 0
#define PRMSIZ 4
#define HIRES 0
#define DNMR 1

struct transitions
{
	int trans_no;		// transition number 
	double intensity;	// transition intensity 
	double calc_freq;	// transition frequency 
	double obs_freq;	// observed frequency transition assigned to 
	double rel_width;	// relative line width (used by DOR) 
};

// The structure holding the chemical shift information 
struct shift_info
{
	char type[10];		// number of spins and symmetry 
	double freq;		// chemical shift in Hz
	char species[20];	// species identifier 
	int spin;			// the spin identifier (twice actual spin) 
	char label[16];		// a chemical shift label 
	short iterate;    	// iterate on this shift? 
};

int sim_main(const char * spin_system, const char *sim_out, 
			 const char *trans_out, const char *trans_file);

//	external functions 
extern int finish();

