// sim_main.cpp : Defines the entry point for the console application.
//

#include <stdio.h>
#include "nummrit.h"
#include "init_sim.h"
#include "basis.h"
#include "hamil.h"
#include "trnout.h"
#include "input_sim.h"

#include <string.h>
#include <time.h>

//	program global variables
short sim_debug = FALSE;		// cause program to dump a lot of debugging info
extern int get_string(int lim, char * str, FILE *ifp);

//-------------------------------------------------------------------------------------------------
//	Visual studio generate main entry point
//int _tmain(int argc, char *argv[]/* _TCHAR* argv[]*/)

//	replaced by conventional C type entry point
int main(int argc, char *argv[])
{

	FILE *ifp;
	char instring[256], spin_system[256], sim_out[256], trans_out[256], trans_file[256];

	printf("argc = %d \n\n", argc);

	/*if((argc == 6 && strcmp(argv[5], "-db") == 0) ||
	   (argc == 5 && strcmp(argv[4], "-db") == 0))
			sim_debug = TRUE;

	int ret_val = sim_main(argv[1], argv[2], argv[3], argv[4]);*/

	if((argc == 2 && strcmp(argv[1], "-db") == 0) ||
	   (argc == 3 && strcmp(argv[2], "-db") == 0))
			sim_debug = TRUE;

	ifp = fopen(argv[1], "r");

	get_string(256, spin_system, ifp);

	//fgets(instring, sizeof(instring), ifp);
	//printf("%s\n", instring);
	//sscanf(instring, "%s", spin_system);
	////strncpy(spin_system, instring, strlen(instring));
	printf("%s\n",spin_system);

	get_string(256, sim_out, ifp);

	//fgets(instring, sizeof(instring), ifp);
	//printf("%s\n",instring);
	//sscanf(instring, "%s", sim_out);
	////strncpy(sim_out, instring, strlen(instring));
	printf("%s\n",sim_out);

	get_string(256, trans_out, ifp);

	//fgets(instring, sizeof(instring), ifp);
	//printf("%s\n",instring);
	//sscanf(instring, "%s", trans_out);
	////strncpy(trans_out, instring, strlen(instring));
	printf("%s\n",trans_out);

	get_string(256, trans_file, ifp);
	//fgets(instring, sizeof(instring), ifp);
	//printf("%s\n",instring);
	//sscanf(instring, "%s", trans_file);
	////strncpy(trans_file, instring, strlen(instring));
	printf("%s\n",trans_file);

	printf("\n");
	printf("*************************\n\n");

	fclose(ifp);

	int ret_val = sim_main(spin_system, sim_out, trans_out, trans_file);

	return ret_val;
}

//-------------------------------------------------------------------------------------------------
int sim_main(const char *spin_system, const char *sim_out, 
			 const char *trans_out, const char *trans_file)
{
	time_t ltime;
	long start_time, finish_time;
	int elapsed_time;
	char dummy_str[128];

	short oldham = FALSE;

	printf("********************\n");

	printf("spin system: %s\n", spin_system);
	printf("text output file: %s\n", sim_out);
	printf("transition output file: %s\n", trans_out);
	printf("assigned transition file: %s\n", trans_file);

	//printf("length = %d\n", strlen(sim_out));

	int error = FALSE;									// means no error (yet)

	FILE *outfile = fopen(sim_out, "w");

	if(outfile == NULL)
	{
		printf("cannot open %s for writing, simulation aborted\n", sim_out);

		char err_str[256];
		perror(err_str);

		printf("error string: %s\n", err_str);
		return ERROR;
	}

	fprintf(outfile, "***  SpinWorks simulation output, build 2008/09/29  ***\n\n");
	
	// _strtime(dummy_str);
	// fprintf(outfile, "       time:  %s\n", dummy_str);
	// _strdate(dummy_str);
	// fprintf(outfile, "       date:  %s\n", dummy_str);
	
	fclose(outfile);

	time(&ltime);										// start a timer
	start_time = (long)ltime;
	error = init_sim();									// initialize parameters and allocate
														// common array areas
	if(error == FALSE)
	{

		error = input(spin_system, sim_out, trans_file);// get the input

		if(error == FALSE)
			error = basis(sim_out);						// generate basis functions

		if(error == FALSE) 
			error = hamlup(sim_out, oldham);			// simulation/optimization loop

		if(error == FALSE)
			tran_out(sim_out, trans_out);				// print transitions, etc.
	}

	if(error != FALSE)
	{
		FILE *outfile = fopen(sim_out, "a");
		fprintf(outfile, "\n\n***  Simulation returns an error!  ***\n");
		fclose(outfile);
		finish();
	}
	else
	{
		time(&ltime);
		finish_time = (long)ltime;
		elapsed_time = (int)(finish_time - start_time);
		FILE *outfile = fopen(sim_out, "a");
		fprintf(outfile, "\n\n***  Simulation normal exit  ***\n");
		fprintf(outfile, "     Calculation time = %d seconds\n", elapsed_time);
		fclose(outfile);
		finish();										// tidy up, release space, etc.
	}
	return error;
}
