//  Calculate transition frequencies

#include <stdio.h>
#include "nummrit.h"
#include "maxvalue.h"
#include "matutil.h"
#include <math.h>

extern short sim_debug;

// /isocom/
extern double	*tiiso, *tliso,
				*fliso, *fuiso;
extern int		*isospn, *ntiso,
				*misopa, *misopb, km2p;
extern char		**isonam;
extern char		*prtiso;

// /grpcom/
extern double	*cshift, **cup, **symcup,
				**dip, **symdip;
extern int		*grpiso, *nucg, *pairg,
				*grpspn, fmaxg[MAXGRP+1][MAXGRP+1], *agpb;
extern short	anydip, symspn;
extern char		**grpnam;
extern int		nm2, km2, ne2, nm32, sym2, wgt2,
				*amaxg, *aming, *ag,
				**fg;

// /spncom/
extern int		ngrp, niso, nvar;

// /flgcom/
extern short	autasn, autdel, optmiz, prtptl,
				prtkey, prtdif, prtvcm, pracnd;

// /prmcom/
extern int		prmsiz, prmnum, prmi, 
				prmj, prmd, lowvar;
extern double	rngdef, rngnit, rngmin;
extern double	*asnhi, *asnlow,
				*rhics,	*rlocs, rngfra,
				**rhiccj, **rloccj,
				**rhiscj, **rloscj,
				**rhiccd, **rloccd,
				**rhiscd, **rloscd;
extern int		*asnmin, *asnnum,
				**prmmap, *ivcs,
				**ivcup, **ivdip;

//	/asncom/
extern double	*asnfrq, *asnwgt, *asndif, *asnclc, asnint;
extern int		asncnt,	*asnlin;

extern double	**bfactf, **bfactg;

extern short	chkasn, difzer[MAXGRP + 1];

// /mat2cm/
extern double   **tub, *t44;
extern double	**tr_u3, **tr_e3;
extern int		u3_size;	// u3 size calculated by basis()
extern int		e3_size;	// e3 size calculated by basis()

// /wrkcom for trnclc/
int				**tr_miso43, **tr_le43, **tr_agp, *tr_mga;
double			* tr_fdif;
		
//extern CString sim_out;

//#define DUMP_LOG

////////////////////////////////////////////////////////////////////////////////

int trnclc(const char *sim_out, short savtran, short dodifs)
{
//     Two matrices(3), a and b , are treated at a time.
//     Here are the labels used consistently in the subroutine.
//
//     m3a,m3b     - indices of the current matrices(3)
//     m4a,m4b     - indices of the current matrices(4)
//     ka ,kb      - first functions in the current matrices(4)
//     la ,lb      - last  functions in the current matrices(4)
//     ne4a,ne4b   - numbers of functions in matrices(4)
//                    i.e.  ne4a=la-ka+1

	int error = FALSE;
	short debug = sim_debug;						// FALSE for production
	int ow = 0;

//	double	**tr_u3, **tr_e3;
	double	edif[MAXE3+1][MAXVAR+1][3];			// add a 3d Matrix allocatiion routine?

//	int		**tr_miso43, **tr_le43, 
//			**tr_agp;	
	int		mg[MAXGRP+1][MAXE3+1][3];			// add a 3d Matrix allocatiion routine?
//	int		*tr_mga;
	
	short	oktran;

	int		apacka, i, id, in4, iv, ixasn, ixiso,
			j, ja, jb, jg, jja, jjb, j_line_no, ju3a,
			ju3b, ka, kb, kdif, kg, k_line_no,
			km32m1, km32, kp, kt, ku3a, ku3b, la, lb,
			m, md, mpacka, mpdif, m3a, m3b, m4a, m4b,
			n, nd, ne3a, ne3b, ne3d, ne4a, ne4b,
			nm43a, nm43b, nu3a, nu3b, nv;

	double freq, ampl, /* *tr_fdif, */ t;
	const double savlim = 1.0e-6;					//////////////////  was 1.0e-6
	const double diflim = 1.0e-10;

	double *e3_temp;
	double *u3_temp;

	FILE *quant;
//	FILE *lines = fopen("lines.txt", "w");
	FILE *ofp = fopen(sim_out, "a");

#ifdef DUMP_LOG
	FILE *fp;
#endif

	if(debug)
	{
		fprintf(ofp, "***  trnclc(): entering routine\n");
		fflush(ofp);
	}

#ifdef DUMP_LOG
	fp = fopen("matdump.txt", "a");
	fprintf(fp, "\n\n*** trnclc(): u3 and e3\n");
	fclose(fp);
#endif

//	tr_u3 = matrix(1, u3_size + 1, 1, 2); 
//	tr_e3 = matrix(1, e3_size + 1, 1, 2);

	e3_temp = vector(0, e3_size + 1);
	u3_temp = vector(0, u3_size + 1);

//	t44 = vector(1, MAXE4);
//	tub = matrix(1, MAXE4, 1, MAXE4);		// 256*256 !

/*
#ifdef DUMP_LOG
	fp = fopen("matdump.txt", "a");
	fprintf(fp, "\n*** trnclc(): tr_miso43, tr_le43, tr_agp tr_mga and tr_fdif\n");
	fclose(fp);
#endif

	tr_miso43 = imatrix(1, MAXM43, 1, 2);
	tr_le43 = imatrix(1, MAXM43, 1, 2);
	tr_agp = imatrix(1, e3_size + 1, 1, 2);
	tr_mga = ivector(1, MAXGRP);
	tr_fdif = vector(1, MAXVAR);
*/
	
	if(debug)quant = fopen("quant_trn.txt", "w");

	if(debug)
	{
		fprintf(quant, "***  Quantum number read by trnclc():\n");
		fflush(quant);
	}

//	fprintf(lines, "***** line information\n");
//	fprintf(lines, 
//		"km2 km32m1 km32 iso j_line_no   freq      ampl  mpacka m4a jja m4b jjb\n");
//	fflush(lines);


	if(debug)
	{
		fprintf(ofp, "***  trnclc(): opening scratch files\n");
		fflush(ofp);
	}

	FILE *scratch1 = fopen("scratch.1", "rb");			// QUANT
	FILE *scratch2 = fopen("scratch.2", "rb");			// EU
	FILE *scratch3; 
	FILE *scratch4;

	if(dodifs)
	{
		scratch3 = fopen("scratch.3", "rb");			// IDERIV
		scratch4 = fopen("scratch.4", "wb");			// IDIF
	}

	FILE *isoscr[MAXISO];

	char dummy[20];
	for(i = 1; i <= niso; i++)
	{
		sprintf(dummy, "isoscr.%d", i);
		isoscr[i] = fopen(dummy, "wb");
		if(isoscr[i] == NULL)
		{
			fprintf(ofp, "*** cannot open isotopic species %d scratch file\n", i);
			fflush(ofp);
		}
	}

	if(debug)
	{
		fprintf(ofp, "***  trnclc(): scratch files opened\n");
		fflush(ofp);
	}

	if(optmiz == TRUE)  asnint = 0.0;
	dclear(MAXVAR, tr_fdif, 0.0);

	j_line_no = 0;		k_line_no = 0;

l1000:;	// continue  CHANGE THIS!!!

//  Start a matrix(2) by reading quantum nos. from quant.	
	fread(&km2, sizeof(int), 1, scratch1);
	fread(&ne2, sizeof(int), 1, scratch1);
	fread(&nm32, sizeof(int), 1, scratch1);
	fread(&wgt2, sizeof(int), 1, scratch1);
	fread(&sym2, sizeof(int), 1, scratch1);

//	fread(&amaxg[1], sizeof(int), MAXGRP, scratch1);
//	fread(&aming[1], sizeof(int), MAXGRP, scratch1);
	for(i=1; i <= MAXGRP; i++)
		fread(&amaxg[i], sizeof(int), 1, scratch1);
	for(i=1; i <= MAXGRP; i++)
		fread(&aming[i], sizeof(int), 1, scratch1);

//	fread(&fg[1][1], sizeof(int), 2*MAXGRP, scratch1);
	for(i = 1; i <= MAXGRP; i++) fread(&fg[1][i], sizeof(int), 1, scratch1);
	for(i = 1; i <= MAXGRP; i++) fread(&fg[2][i], sizeof(int), 1, scratch1);

//	fread(&bfactf[1][1], sizeof(int), MAXF*MAXGRP, scratch1);
	for(i = 1; i <= MAXF; i++)
		for(j = 1; j <= MAXGRP; j++)
			fread(&bfactg[i][j], sizeof(int), 1, scratch1);

//	fread(&bfactg[1][1], sizeof(int), MAXF*MAXGRP, scratch1);
	for(i = 1; i <= MAXF; i++)
		for(j = 1; j <= MAXGRP; j++)
			fread(&bfactg[i][j], sizeof(int), 1, scratch1);

	if(debug)
	{
		fprintf(ofp, "***  trnclc(): quantum numbers read from scratch1\n");
		fflush(ofp);
	}

	// first matrix(3)
	m3b = 1;

	goto l1110;

l1100:;	// continue

//	Here the old matrix(3)b becomes the matrix(3)a.
//	Matrix(3)b is always the newest one read from
//	quant and eu. Matrix(3)a is always the old one.
//	each time a new matrix(3) is read in, the indices
//	1 and 2 are exchanged between a and b.

	m3a = m3b;
	m3b = 3 - m3b;	// swap index 1 with index 2
	nm43a = nm43b;
	ne3a = ne3b; 
	nu3a = nu3b;

l1110:;	// continue

//	For new maxtrix(3)b
//	- read quantum no's from quant
//	- read eigenvalues and vectors from eu
 

//  reading "QUANT" //////////////////////
	fread(&km32, sizeof(int), 1, scratch1);
	fread(&m, sizeof(int), 1, scratch1);
	fread(&nm43b, sizeof(int), 1, scratch1);
	fread(&ne3b, sizeof(int), 1, scratch1);

	if(debug)
	{
		fprintf(ofp, "***  trnclc(): more quantum numbers read from scratch1\n");
		fflush(ofp);
	}

	for(i = 1; i <= nm43b; i++)
	{
		fread(&tr_le43[i][m3b], sizeof(int), 1, scratch1);
		fread(&tr_miso43[i][m3b], sizeof(int), 1, scratch1);
	}

	for(i = 1; i <= ne3b; i++)
		fread(&tr_agp[i][m3b], sizeof(int), 1, scratch1);

	for(i = 1; i <= ngrp; i++)
	{
		for(j = 1; j <= ne3b; j++)
		{
			fread(&mg[i][j][m3b], sizeof(int), 1 , scratch1);
		}
	}

	if(debug)
	{
		fprintf(quant, "TRNCLC: reading quant, m3b = %d\n", m3b);
		fprintf(quant, "   km2= %d  ne2= %d, nm32= %d, wgt2= %d, sym2= %d\n",
			km2, ne2, nm32, wgt2, sym2);

		fprintf(quant, "TRNCLC: read from QUANT (scratch1)\n");
		fprintf(quant, "  km32= %d, m= %d, nm43= %d, ne3= %d\n",
				km32, m, nm43b, ne3b);

		for(i=1; i<=nm43b; i++)
			fprintf(quant, "  tr_le43[%d]=%d, tr_miso43[%d]=%d;  ",
			i, tr_le43[i][m3b], i, tr_miso43[i][m3b]);

		fprintf(quant, "\n");

		for(i=1; i<=ne3b; i++)
			fprintf(quant, "  tr_agp[%d]=%d",i, tr_agp[i][m3b]);

		fprintf(quant,"\n");

		for(i=1; i<=ngrp; i++)
		{
			for(int j=1; j<=ne3b; j++)
			{
				fprintf(quant, "  mg[%d][%d]=%d", i, j, mg[i][j][m3b]);
			}
			fprintf(quant,"\n");
		}
		fflush(quant);
	}

	if(debug)
	{
		fprintf(ofp, "***  trnclc(): all quantum numbers read\n");
		fflush(ofp);
	}

//	reading "EU" ///////////////////////

	fread(&nu3b, sizeof(int), 1, scratch2);
	if(debug)fprintf(quant, "  ***** nu3b = %d,   error code = %d   %d\n",
		 nu3b, ferror(scratch2), feof(scratch2));

	if(debug)fprintf(quant, "TRNCLC: energies and eigenvectors generated by HAMIL for");
	if(debug)fprintf(quant, " ne3b = %d, nu3b = %d \n", ne3b, nu3b);
	if(debug)fflush(quant);

//  read energies
	ow = ow + fread(e3_temp, 1, sizeof(double) * ne3b, scratch2);

	for(i = 1; i <= ne3b; i++)
	{
        tr_e3[i][m3b] = e3_temp[i-1];
	}

	if(debug)
	{
		fprintf(quant, "  total bytes read after E3 = %d, error = %d, eof = %d \n", 
			ow, ferror(scratch2), feof(scratch2));
		fflush(quant);
	}


	// read eigenvectors
	ow = ow + fread(u3_temp, 1, sizeof(double) * nu3b, scratch2);

	for(i = 1; i <= nu3b; i++)
	{
		tr_u3[i][m3b] = u3_temp[i-1];
	}
	
	if(debug)
	{
		fprintf(quant, "  total bytes read after U3 = %d, error = %d, eof= %d \n", 
			ow, ferror(scratch2), feof(scratch2));
		fflush(quant);
	}

//  now dump what we read
	if(debug)
	{
		for(i = 1; i <= ne3b; i++)
			fprintf(quant, " %d  %f\n", i, tr_e3[i][m3b]);
		fprintf(quant,"\n");
		for(i = 1; i <= nu3b; i++)
			fprintf(quant, " %d  %f\n", i, tr_u3[i][m3b]);
		fprintf(quant,"***  trnclc(): energy and eigenvector dump complete\n\n");
		fflush(quant);
	}


//	Read partial derivatives of eigenvalues from
//	ideriv, for parameter iv and matrix(3)m3b.
	if(dodifs == TRUE)
	{
		fread(&ne3d, sizeof(int), 1, scratch3);
		for(in4 = 1; in4 <= nm43b; in4++)
		{
			for(iv = 1; iv <= nvar; iv++)
			{
				fread(&md, sizeof(int), 1, scratch3);
				fread(&nd, sizeof(int), 1, scratch3);
				fread(&nv, sizeof(int), 1, scratch3);
				if(debug)fprintf(quant, "\n***  trnclc(): md = %d    nd = %d    nv = %d\n",
					md, nd, nv);
				for(id = md; id <= nd; id++)
				{
					fread(&edif[id][nv][m3b], sizeof(double), 1, scratch3);
					if(debug)fprintf(quant, "       edif[%d][%d][%d] = %f\n", 
						id, nv, m3b, edif[id][nv][m3b]);
				}
				if(debug)fflush(quant);
			}														// 1130
		}															// 1140
	}																// endif

//	If this is first matrix(3), go back for another one.
	if(km32 == 1) goto l1100;

	km32m1 = km32 - 1;

	for(ixiso = 1; ixiso <= niso; ixiso++)							// do 2000
	{
		if(debug)
		{
			fprintf(ofp, "***  trnclc(): isotopic species %d\n", ixiso);
			fflush(ofp);
		}
	
		// mpdif controls selection rule for
		// transitions of this species.
		mpdif = 2 * misopb[ixiso];

		ku3a = 0;
		j_line_no = k_line_no;
		la = 0;
		m4a = 1;

		// start a new matrix(4) in matrix(3)a
l1200:; // continue
		
		ka = la + 1;
		la = tr_le43[m4a][m3a];
		ne4a = 1 + la - ka;
		mpacka = tr_miso43[m4a][m3a];
		ku3b = 0;
		lb = 0;
		m4b = 1;

		// start a new matrix(4) in matrix(3)b
l1250:;	// continue

		kb = lb + 1;
		lb = tr_le43[m4b][m3b];
		ne4b = 1 + lb - kb;

		// test selection rules for species 'm's
		if(mpacka - tr_miso43[m4b][m3b] != mpdif)
		{
			// transitions NOT allowed between these matrices(4)
			// for this species
			j_line_no = j_line_no + ne4a * ne4b;
		}
		else
		{
			// transitions ARE allowed
			jja = 0;

			if(savtran || dodifs)
			{
				// generate tu matrix
				for(ja = ka; ja <= la; ja++)						// do 1380
				{
					jja = jja +1;
					apacka = tr_agp[ja][m3a];
					kp = apacka;

					for(kg = 1; kg <= ngrp; kg ++)					// do 1320
					{
						tr_mga[kg] = mg[kg][ja][m3a];
						ag[kg] = kp/agpb[kg];
						kp = kp - ag[kg] * agpb[kg];
					}												// 1320
					// Run through the levels in the
					// current matrix(4)b.
					kt = 0;
					for (jb = kb; jb <= lb; jb++)					// do 1350
					{
						kt = kt + 1;	// count one transition
						t = 0.0;

						// Test selection rule for basis
						// function group a's (don't change).
						if(tr_agp[jb][m3b] != apacka) goto l1340;

						// Test selection rule for
						// group m's (one changes).
						kdif = 0;

						for(kg = 1; kg <= ngrp; kg++)			// do 1330
						{
							if(mg[kg][jb][m3b] != tr_mga[kg])
							{
								kdif = kdif + 1;
								if(kdif > 1) goto l1340;
								jg = kg;	// jg labels the group whose m changes
							}									// endif
						}										// 1330

						// Intensity contribution from
						// this pair of basis functions
						t = (ag[jg] + tr_mga[jg]) * (2 + ag[jg] - tr_mga[jg]);
						t = 0.5 * sqrt(t);

l1340:;	// continue

						// t44 is one line of the t matrix
						t44[kt] = t;
					}												// 1350
					ju3b = ku3b;
					for(jjb = 1; jjb <= ne4b; jjb++)				// do 1370
					{
						t = 0.0;
						for(n = 1; n <= ne4b; n++)					// do 1360
						{
							ju3b = ju3b + 1;
							t = t + t44[n] * tr_u3[ju3b][m3b];
						}											// 1360
						tub[jja][jjb] = t;
					}												// 1370
				}													// 1380 end of tu generation
			}														// endif (savtrn or dodifs)	
			jb = kb;
			jjb = 0;

l1400:;	// continue

			jjb++;
			ja = ka;
			jja = 0;
			ju3a = ku3a;

l1420:;	// continue

			jja++; 
			j_line_no++;							// incr. line number
			freq = tr_e3[ja][m3a] - tr_e3[jb][m3b];		// calculate frequency

			// If optimizing, see if this transition
			// corresponds to an observed one. If so
			// save its frequency (later total it's ampl).

			oktran = FALSE;
			ixasn = 0;
			if(optmiz == TRUE)
			{
				ixasn = binint(MAXASN, asncnt, asnlin, j_line_no);
			}

			if(ixasn != 0)
			{
				asnclc[ixasn] = freq;
				oktran = TRUE;
			}														// endif

			if(savtran || dodifs)
			{
				// calculate transition intensity.  transition is
				// saved if it's  intensity is above a small threshold
				ampl = 0.0;
				for(n = 1; n <= ne4a; n++)							// do 1430
				{
					ju3a++;
					// add one element of the utu matrix;
					ampl = ampl + tr_u3[ju3a][m3a]*tub[n][jjb];
				}													// 1430

				ampl = ampl * ampl * (double)wgt2;
				oktran = oktran || (fabs(ampl) >= savlim);

				if(dodifs && oktran)
				{
					for(iv = 1; iv <= nvar; iv++)					// do 1710
					{
						if(difzer[iv])
						{
							difzer[iv] = (short)(fabs(tr_fdif[iv]) <= diflim);
						}											// endif
						tr_fdif[iv] = edif[ja][iv][m3a] 
							     - edif[jb][iv][m3b];
					}												// 1710

					fwrite(&j_line_no, sizeof(int), 1, scratch4);		// IDIF
					for(iv = 1; iv <= MAXVAR; iv++)
						fwrite(&tr_fdif[iv], sizeof(double), 1, scratch4);

				}													// endif

				if(optmiz && (ixasn != 0))
				{
					asnint = asnint + ampl;
//					fprintf(ofp, "***  trnclc(): ixasn= %d asnlin = %d\n",
//						ixasn, asnlin[ixasn]);
				}

				if(oktran)
				{
//					fprintf(lines, " %3d %3d %3d %3d   %4d %10.3f %10.5f  %3d %3d %3d %3d %3d  \n",
//					km2, km32m1, km32, ixiso, j_line_no, freq, ampl, mpacka, m4a, jja,
//					m4b, jjb);
//					fflush(lines);
					if(debug)
					{
						fprintf(ofp, "***  trnclc(): dump line %d to lines\n", j_line_no);
						fflush(ofp);
					}
				}

				if(savtran && oktran)
				{
					fwrite(&km2, sizeof(int), 1, isoscr[ixiso]);
					if(debug)
					{
						fprintf(ofp, "    km2 writen to isoscr.[%d]\n", ixiso);
						fflush(ofp);
					}
					fwrite(&km32m1, sizeof(int), 1, isoscr[ixiso]);
					if(debug)
					{
						fprintf(ofp, "    km32m1 writen to isoscr.[%d]\n", ixiso);
						fflush(ofp);
					}
					fwrite(&km32, sizeof(int), 1, isoscr[ixiso]);
					fwrite(&ixiso, sizeof(int), 1, isoscr[ixiso]);
					fwrite(&j_line_no, sizeof(int), 1, isoscr[ixiso]);
					fwrite(&freq, sizeof(double), 1, isoscr[ixiso]);
					fwrite(&ampl, sizeof(double), 1, isoscr[ixiso]);
					fwrite(&mpacka, sizeof(int), 1, isoscr[ixiso]);
					fwrite(&m4a, sizeof(int), 1, isoscr[ixiso]);
					fwrite(&jja, sizeof(int), 1, isoscr[ixiso]);
					fwrite(&m4b, sizeof(int), 1, isoscr[ixiso]);
					fwrite(&jjb, sizeof(int), 1, isoscr[ixiso]);
				}													// endif
				if(debug)
				{
					fprintf(ofp, "***  trnclc(): finished writing to isoscr.[%d]\n", ixiso);
					fflush(ofp);
				}
			}														// endif (savtran || dodifs)

			ja++;
			if(ja <= la) goto l1420;

			jb++;
			if(jb <= lb) goto l1400;
		}															// endif (else)

		ku3b = ku3b + ne4b*ne4b;
		m4b++;
		if(m4b <= nm43b) goto l1250;
		ku3a = ku3a + ne4a*ne4a;
		m4a++;
		if(m4a <= nm43a) goto l1200;
		if(debug)
		{
			fprintf(ofp, "***  trnclc(): at end of species loop\n");
			fflush(ofp);
		}
	}	// end of species loop										// 2000
	
	k_line_no = j_line_no;

	if(km32 < nm32) goto l1100;		// back for a new matrix(3)

	if(km2 < nm2) goto l1000;		// back for a new matrix(2)

	if(debug)
	{
		fprintf(ofp, "***  trnclc(): closing scratch files\n");
		fflush(ofp);
	}

//	now close up any open files
	fclose(scratch1);
	fclose(scratch2);

	if(dodifs)
	{
		fclose(scratch3);
		fclose(scratch4);
	}

	for(i = 1; i <= niso; i++)
		fclose(isoscr[i]);

	if(debug)
	{
		fclose(quant);
	}

//	fclose(lines);

#ifdef DUMP_LOG
	fp = fopen("matdump.txt", "a");
	fprintf(fp, "\n*** trnclc(): e3 and u3\n");
	fclose(fp);
#endif

	free_vector(e3_temp, 0, e3_size + 1);
	free_vector(u3_temp, 0, u3_size + 1);	
	

#ifdef DUMP_LOG
	fp = fopen("matdump.txt", "a");
	fprintf(fp, "\n*** trnclc(): space freed\n");
	fclose(fp);
#endif 
//	free_matrix(tub, 1, MAXE4, 1, MAXE4);
//	free_vector(t44, 1, MAXE4);

/*
#ifdef DUMP_LOG
	fp = fopen("matdump.txt", "a");
	fprintf(fp, "\n*** trnclc(): tr_miso43, tr_le43, tr_agp tr_mga and tr_fdif\n");
	fclose(fp);
#endif
	free_imatrix(tr_miso43, 1, MAXM43, 1, 2);
	free_imatrix(tr_le43, 1, MAXM43, 1, 2);
	free_imatrix(tr_agp, 1, e3_size + 1, 1, 2);		// also here???
	free_ivector(tr_mga, 1, MAXGRP);
	free_vector(tr_fdif, 1, MAXVAR);
*/

	if(debug)fprintf(ofp, "***  trnclc(): exiting, return code = %d\n", error);
	fclose(ofp);
	return error;
}

#ifdef DUMP_LOG
#undef DUMP_LOG
#endif
